/**=============================================================================================+
|===================   fantacalcioGUI   ========================================================|
+===============================================================================================+
|  Programma per il calcolo del fantacalcio con GUI                                             |
|  Autore: Marco Segato <segatom@yahoo.it> aka Mach <tumin17@yahoo.it>                          |
|  Website: http://www.marcosegato.tk                                                           |
|  Versione: leggi 'final String VERSION' alla riga 19                                          |
|  Programma rilasciato sotto licenza GPL, http://www.gnu.org                                   |
+----------------------------------------------------------------------------------------------*/

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import javax.swing.border.*;

public class fantacalcioGUI
{ public static void main (String[]args)
	{ final String VERSION = "2.6 - 2003.09.21";		// VERSIONE PROGRAMMA
	MyFrame frame = new MyFrame();				// creazione frame principale
	frame.setTitle("fantacalcioGUI v"+VERSION);		// titolo frame principale
	
	Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize(); // posiziona il frame nella pagina
	Dimension frameSize = frame.getSize();
	if (frameSize.height > screenSize.height)
		{ frameSize.height = screenSize.height;
		}
	if (frameSize.width > screenSize.width)
		{ frameSize.width = screenSize.width;
		}
	frame.setLocation((screenSize.width - frameSize.width)/2, (0));
	frame.show();						// visualizza frame principale
	}
}

class LFrame extends JFrame					// frame licenza
{ public LFrame()
	{ setSize(550, 500);
	licenseArea = new JTextArea();
	licenseArea.setEditable(false);
	licenseArea.setBackground(Color.white);

	try
		{ BufferedReader licenseIn = null;
		licenseIn = new BufferedReader(new FileReader("LICENSE.txt"));
		String tmp = "";
		String inputLicense = "";
		boolean fatto = false;
		while(tmp != null)
			{ tmp = licenseIn.readLine();
			inputLicense = inputLicense+tmp+'\n';
			}
		licenseArea.setText(inputLicense);
		licenseIn.close();
		}
		catch(Exception e)
		{ JOptionPane.showMessageDialog(null, "Errore! Licenza non trovata.");
		licenseArea.setText("Visita il sito http://www.gnu.org per una versione\naggiornata della licenza di questo programma.");
		}
	licenseSP = new JScrollPane(licenseArea);
	Container LContentPane = getContentPane();
	LContentPane.add (licenseSP, "Center");
	}
	private JTextArea licenseArea;
	private JScrollPane licenseSP;
}

class StatFrame extends JFrame				// frame statistiche giocatori
{ public StatFrame()
	{ int i, j;
	int numnomi = 3;
	int numdati = 11;					// numero dati visualizzati oltre al nome del giocatore
	setSize(900, 470);
	ActionListener sListener = new StatButtonAction();	// ACTION-LISTENER x i pulsanti

	JPanel SbuttonPanel = new JPanel();			// pannello NORTH
	caricaButton = new JButton("Carica formazione", new ImageIcon("./gfx/open.png"));
	caricaButton.addActionListener(sListener);
	SbuttonPanel.add(caricaButton);
	apriButton = new JButton("Apri database statistiche", new ImageIcon("./gfx/stat.png"));
	apriButton.addActionListener(sListener);
	SbuttonPanel.add(apriButton);
	
	nomiMatrix = new JTextField[19][numnomi+1];		// campi testo per nomi
	for (i=1;i<19;i++)
		{ for (j=1;j<(numnomi+1);j++)
			nomiMatrix[i][j] = new JTextField(10);
		}
	statMatrix = new JTextField[19][numdati+1];		// campi testo per dati
	for (i=1;i<19;i++)
		{ for (j=1;j<(numdati+1);j++)
			statMatrix[i][j] = new JTextField(4);
		}

	JPanel SnomiPanel = new JPanel();			// pannello nomi
	SnomiPanel.setLayout (new GridLayout(19,3));
	SnomiPanel.add(new JLabel("Codice"));
	SnomiPanel.add(new JLabel("Nome giocatore"));
	SnomiPanel.add(new JLabel("Squadra"));
	for (i=1;i<19;i++)
		{ for (j=1;j<(numnomi+1);j++)
			SnomiPanel.add(nomiMatrix[i][j]);
		}
	JPanel SdatiPanel = new JPanel();			// pannello dati
	SdatiPanel.setLayout (new GridLayout(19,numdati));
	SdatiPanel.add(new JLabel("ruolo"));
	SdatiPanel.add(new JLabel("v.fant"));
	SdatiPanel.add(new JLabel("v.part"));
	SdatiPanel.add(new JLabel("g.f."));
	SdatiPanel.add(new JLabel("g.s."));
	SdatiPanel.add(new JLabel("assist"));
	SdatiPanel.add(new JLabel("amm."));
	SdatiPanel.add(new JLabel("esp."));
	SdatiPanel.add(new JLabel("rig.f"));
	SdatiPanel.add(new JLabel("rig.s"));
	SdatiPanel.add(new JLabel("costo"));
	for (i=1;i<19;i++)
		{ for (j=1;j<(numdati+1);j++)
			SdatiPanel.add(statMatrix[i][j]);
		}

	JPanel SwestPanel = new JPanel();			// pannello WEST
	SwestPanel.add(SnomiPanel);
	JPanel ScenterPanel = new JPanel();			// pannello CENTER
	ScenterPanel.add(SdatiPanel);

	Container SContentPane = getContentPane();		// DISPOSIZIONE PANNELLI SU FRAME
	SContentPane.add (SbuttonPanel, "North");
	SContentPane.add (SwestPanel, "West");
	SContentPane.add (ScenterPanel, "Center");
	}
	private JButton caricaButton;
	private JButton apriButton;
	private JTextField[][] nomiMatrix;
	private JTextField[][] statMatrix;

	private class StatButtonAction implements ActionListener // intercetta eventi nei pulsanti
	{ public void actionPerformed(ActionEvent sEvent)
		{ Object sSource = sEvent.getSource();		// trova pulsante premuto
		int i, j;
		String ruolo = "";

		if (sSource == caricaButton)			// pulsante CARICA FORMAZIONE
			{ try
				{ JFileChooser chooser = new JFileChooser();
				if (chooser.showOpenDialog(null) == JFileChooser.APPROVE_OPTION)
					{File selectedFile = chooser.getSelectedFile();
					BufferedReader formazIn = null;
					formazIn = new BufferedReader(new FileReader(selectedFile));
					String inputFormaz;
					for(i=1;i<19;i++)
						{ inputFormaz = formazIn.readLine();
						if (inputFormaz.endsWith(" ") || inputFormaz.startsWith(" "))
							inputFormaz.trim();
						nomiMatrix[i][2].setText(inputFormaz);
						if (nomiMatrix[i][2].getText().equals(""))
							throw new IllegalArgumentException();
						}
					formazIn.close();
					}
				}
			catch(IllegalArgumentException e)
				{ JOptionPane.showMessageDialog(null, "Formazione non valida.");
				}
			catch(IOException e)
				{ JOptionPane.showMessageDialog(null, "Errore di apertura del file.");
				}
			}
		if (sSource == apriButton)			// pulsante APRI DATABASE STATISTICHE
			{ try
				{ for(i=1;i<19;i++)
					if (nomiMatrix[i][2].getText().equals(""))
						throw new NullPointerException();
				JFileChooser chooser = new JFileChooser();
				if (chooser.showOpenDialog(null) == JFileChooser.APPROVE_OPTION)
					{ File selectedFile = chooser.getSelectedFile();
					for (i=1;i<19;i++)	// legge e scrive tutti i datii
						{ if(trovaDato.datoFanta(selectedFile, (nomiMatrix[i][2].getText()).trim(), 1).equals(""))
							throw new NullPointerException();
						nomiMatrix[i][1].setText(trovaDato.datoFanta(selectedFile, (nomiMatrix[i][2].getText()).trim(), 1) ); // 1 = posizione codice giocatore
						nomiMatrix[i][3].setText(trovaDato.datoFanta(selectedFile, (nomiMatrix[i][2].getText()).trim(), 4) ); // 4 = posizione squadra giocatore
						ruolo = trovaDato.datoFanta(selectedFile, (nomiMatrix[i][2].getText()).trim(), 6); // 6 = posizione ruolo giocatore
						if (ruolo.equals("0"))
							statMatrix[i][1].setText("port");
						else if (ruolo.equals("1"))
							statMatrix[i][1].setText("dif");
						else if (ruolo.equals("2"))
							statMatrix[i][1].setText("cent");
						else if (ruolo.equals("3"))
							statMatrix[i][1].setText("att");
						statMatrix[i][2].setText(trovaDato.datoFanta(selectedFile, (nomiMatrix[i][2].getText()).trim(), 8) ); // 8 = posizione voto giocatore
						statMatrix[i][3].setText(trovaDato.datoFanta(selectedFile, (nomiMatrix[i][2].getText()).trim(), 11) ); // 11 = posizione voto partita
						statMatrix[i][4].setText(trovaDato.datoFanta(selectedFile, (nomiMatrix[i][2].getText()).trim(), 12) ); // 12 = posizione gol fatti
						statMatrix[i][5].setText(trovaDato.datoFanta(selectedFile, (nomiMatrix[i][2].getText()).trim(), 13) ); // 13 = posizione gol subiti
						statMatrix[i][6].setText(trovaDato.datoFanta(selectedFile, (nomiMatrix[i][2].getText()).trim(), 16) ); // 16 = posizione assist
						statMatrix[i][7].setText(trovaDato.datoFanta(selectedFile, (nomiMatrix[i][2].getText()).trim(), 17) ); // 17 = posizione ammonizioni
						statMatrix[i][8].setText(trovaDato.datoFanta(selectedFile, (nomiMatrix[i][2].getText()).trim(), 18) ); // 18 = posizione espulsioni
						statMatrix[i][9].setText(trovaDato.datoFanta(selectedFile, (nomiMatrix[i][2].getText()).trim(), 19) ); // 19 = posizione rigori tirati
						statMatrix[i][10].setText(trovaDato.datoFanta(selectedFile, (nomiMatrix[i][2].getText()).trim(), 20) ); // 20 = posizione rigori subiti
						statMatrix[i][11].setText(trovaDato.datoFanta(selectedFile, (nomiMatrix[i][2].getText()).trim(), 28) ); // 28 = posizione costo giocatore
						}
					}
				}
			catch(NullPointerException e)
				{ JOptionPane.showMessageDialog(null, "Formazione non valida o file con i dati errato.");
				}
			catch(StringIndexOutOfBoundsException e)
				{ JOptionPane.showMessageDialog(null, "Errore di apertura del file.");
				}
			}
		}
	}
}

class MyFrame extends JFrame					// frame principale
{ public MyFrame()
	{ final int DEFAULT_FRAME_WIDTH = 800;
	final int DEFAULT_FRAME_HEIGHT = 685;
	setSize(DEFAULT_FRAME_WIDTH, DEFAULT_FRAME_HEIGHT);
	int i; int j;
	String formazione = "";
	int P = 1; int D = 3; int C = 4; int A = 3;

	ActionListener listener = new ButtonAction();		// ACTION-LISTENER x pulsanti
	addWindowListener(new WindowCloser());
	
	MenuListener mListener = new MenuListener();		// MENU LISTENER x menu

	JMenuBar menuBar = new JMenuBar();			// barra dei menu
	setJMenuBar(menuBar);
	JMenu formazioneMenu = new JMenu("Formazione");
	menuBar.add(formazioneMenu);
	JMenu statisticheMenu = new JMenu("Statistiche");
	menuBar.add(statisticheMenu);
	loadMenuItem = new JMenuItem("Carica squadra");
	loadMenuItem.addActionListener(mListener);
	formazioneMenu.add(loadMenuItem);
	saveMenuItem = new JMenuItem("Salva squadra");
	saveMenuItem.addActionListener(mListener);
	formazioneMenu.add(saveMenuItem);
	statMenuItem = new JMenuItem("Dati squadra");
	statMenuItem.addActionListener(mListener);
	statisticheMenu.add(statMenuItem);
	
	Font bigFont = new Font("Monospaced", Font.BOLD, 36);	// font
	Font midFont = new Font("SansSerif", Font.BOLD, 16);
	elencoNomi = new JTextField[19];			// campi di testo per nomi giocatori
	for(i=1;i<19;i++)
		elencoNomi[i] = new JTextField(15);
	elencoSquadre = new JTextField[19];			// campi di testo per squadre giocatori
	for(i=1;i<19;i++)
		elencoSquadre[i] = new JTextField(15);
	elencoVotiP = new JTextField[19];			// campi di testo per voti partita
	for(i=1;i<19;i++)
		{ elencoVotiP[i] = new JTextField(4);
		elencoVotiP[i].setHorizontalAlignment(0);
		elencoVotiP[i].setEditable(false);
		elencoVotiP[i].setBackground(Color.white);
		}
	elencoGolF = new JTextField[19];			// campi di testo per gol fatti
	for(i=1;i<19;i++)
		{ elencoGolF[i] = new JTextField(4);
		elencoGolF[i].setHorizontalAlignment(0);
		elencoGolF[i].setEditable(false);
		elencoGolF[i].setBackground(Color.white);
		}
	elencoGolS = new JTextField[19];			// campi di testo per gol subiti
	for(i=1;i<19;i++)
		{ elencoGolS[i] = new JTextField(4);
		elencoGolS[i].setHorizontalAlignment(0);
		elencoGolS[i].setEditable(false);
		elencoGolS[i].setBackground(Color.white);
		}
	elencoAssist = new JTextField[19];			// campi di testo per assist
	for(i=1;i<19;i++)
		{ elencoAssist[i] = new JTextField(4);
		elencoAssist[i].setHorizontalAlignment(0);
		elencoAssist[i].setEditable(false);
		elencoAssist[i].setBackground(Color.white);
		}
	elencoAmm = new JTextField[19];			// campi di testo per ammonizioni
	for(i=1;i<19;i++)
		{ elencoAmm[i] = new JTextField();
		elencoAmm[i].setHorizontalAlignment(0);
		elencoAmm[i].setEditable(false);
		elencoAmm[i].setBackground(Color.yellow);
		}
	elencoEsp = new JTextField[19];			// campi di testo per espulsioni
	for(i=1;i<19;i++)
		{ elencoEsp[i] = new JTextField(4);
		elencoEsp[i].setHorizontalAlignment(0);
		elencoEsp[i].setEditable(false);
		elencoEsp[i].setBackground(Color.red);
		}
	spazio = new JLabel[19];				// etichetta per creare uno spazio tra le colonne
	for(i=1;i<19;i++)
		spazio[i] = new JLabel("    ");
	elencoVotiF = new JTextField[19];			// campi di testo per voti fantacalcio
	for(i=1;i<12;i++)
		{ elencoVotiF[i]= new JTextField(4);
		elencoVotiF[i].setHorizontalAlignment(0);
		}
	elencoVotiF[1].setBackground(new Color(0,0,153));
	elencoVotiF[1].setForeground(Color.white);
	for(i=P+1;i<=P+D;i++)
		elencoVotiF[i].setBackground(new Color(0,153,204));
	for(i=P+D+1;i<=P+D+C;i++)
		elencoVotiF[i].setBackground(new Color(0,204,255));
	for(i=P+D+C+1;i<=P+D+C+A;i++)
		elencoVotiF[i].setBackground(new Color(102,255,255));
	for(i=12;i<19;i++)					// campi di testo per voti panchina
		{ elencoVotiF[i]= new JTextField(4);
		elencoVotiF[i].setText("0");
		elencoVotiF[i].setHorizontalAlignment(0);
		}
	elencoVotiF[12].setBackground(new Color(0,0,153));
	elencoVotiF[12].setForeground(Color.white);
	elencoVotiF[13].setBackground(new Color(0,153,204));
	elencoVotiF[14].setBackground(new Color(0,153,204));
	elencoVotiF[15].setBackground(new Color(0,204,255));
	elencoVotiF[16].setBackground(new Color(0,204,255));
	elencoVotiF[17].setBackground(new Color(102,255,255));
	elencoVotiF[18].setBackground(new Color(102,255,255));
	resultsField = new JTextField(6);			// campo di testo per i risultati
	resultsField.setEditable(false);
	resultsField.setBackground(Color.white);
	resultsField.setBorder (new EtchedBorder());
	resultsField.setFont(bigFont);
	golField = new JTextField(2);				// campo di testo per i gol
	golField.setEditable(false);
	golField.setBackground(Color.white);
	golField.setBorder (new EtchedBorder());
	golField.setFont(bigFont);
	golLabel = new JLabel("GOL FATTI:");
	golLabel.setFont(midFont);

	JPanel elencoNomiPanel = new JPanel();			// pannello elenco nomi + elenco squadre
	elencoNomiPanel.setToolTipText("Elenco dei nomi dei giocatori");
	elencoNomiPanel.setBorder (new TitledBorder(new BevelBorder(BevelBorder.RAISED,Color.lightGray,Color.white,new Color(124, 124, 124),new Color(178, 178, 178)), " formazione "));
	elencoNomiPanel.setLayout (new GridLayout(20,2));
	tit = new JLabel("Titolari :"); tit.setForeground(Color.blue);
	elencoNomiPanel.add(tit); elencoNomiPanel.add(new JLabel(""));
	for(i=1;i<12;i++)
		{ elencoNomiPanel.add(elencoNomi[i]);
		elencoNomiPanel.add(elencoSquadre[i]);
		}
	panch = new JLabel("Panchina :"); panch.setForeground(Color.red);
	elencoNomiPanel.add(panch); elencoNomiPanel.add(new JLabel(""));
	for(i=12;i<19;i++)
		{ elencoNomiPanel.add(elencoNomi[i]);
		elencoNomiPanel.add(elencoSquadre[i]);
		}
	JPanel squadraPanel = new JPanel();			// pannello squadra
	squadraPanel.setToolTipText("Elenco dei voti dei giocatori");
	squadraPanel.setBorder (new TitledBorder(new BevelBorder(BevelBorder.RAISED,Color.lightGray,Color.white,new Color(124, 124, 124),new Color(178, 178, 178)), " votazioni "));
	squadraPanel.setLayout (new GridLayout(20,8));
	squadraPanel.add(new JLabel("v.part")); squadraPanel.add(new JLabel("gol f."));squadraPanel.add(new JLabel("gol s."));squadraPanel.add(new JLabel("assist"));squadraPanel.add(new JLabel("amm."));squadraPanel.add(new JLabel("esp."));squadraPanel.add(new JLabel("    "));squadraPanel.add(new JLabel("v.fant"));
	for (i=1;i<12;i++)
		for (j=1;j<9;j++)
			{ squadraPanel.add(elencoVotiP[i]);
			squadraPanel.add(elencoGolF[i]);
			squadraPanel.add(elencoGolS[i]);
			squadraPanel.add(elencoAssist[i]);
			squadraPanel.add(elencoAmm[i]);
			squadraPanel.add(elencoEsp[i]);
			squadraPanel.add(spazio[i]);
			squadraPanel.add(elencoVotiF[i]);
			}
	squadraPanel.add(new JLabel("v.part")); squadraPanel.add(new JLabel("gol f."));squadraPanel.add(new JLabel("gol s."));squadraPanel.add(new JLabel("assist"));squadraPanel.add(new JLabel("amm."));squadraPanel.add(new JLabel("esp."));squadraPanel.add(new JLabel("    "));squadraPanel.add(new JLabel("v.fant"));
	for (i=12;i<19;i++)
		for (j=1;j<9;j++)
			{ squadraPanel.add(elencoVotiP[i]);
			squadraPanel.add(elencoGolF[i]);
			squadraPanel.add(elencoGolS[i]);
			squadraPanel.add(elencoAssist[i]);
			squadraPanel.add(elencoAmm[i]);
			squadraPanel.add(elencoEsp[i]);
			squadraPanel.add(spazio[i]);
			squadraPanel.add(elencoVotiF[i]);
			}
	JPanel nomiEsquadraPanel = new JPanel();		// pannello elenco + voti
	nomiEsquadraPanel.setLayout(new GridLayout(1,2));
	nomiEsquadraPanel.add(elencoNomiPanel);
	nomiEsquadraPanel.add(squadraPanel);

	JPanel centerPanel = new JPanel();			// PANNELLO CENTER
	JTextArea avviso = new JTextArea();
	avviso.setEditable(false);
	avviso.setBackground(Color.green);
	avviso.setText("NB: per distinguere due giocatori con lo stesso cognome, inserire anche l'iniziale del nome.\n"+
			"NB2: perche' le sostituzioni siano eseguite correttamente, inserire il modulo di gioco esatto.");
	centerPanel.add(avviso);
	centerPanel.add(nomiEsquadraPanel);

	JPanel buttonPanelSx = new JPanel();			// pannello pulsanti-controllo sx
	buttonPanelSx.setLayout(new GridLayout(3,1));
	buttonPanelSx.setBorder (new EtchedBorder());
	buttonPanelSx.setBackground(new Color (153,153,204));
	saveButton = new JButton("SALVA VOTI", new ImageIcon("./gfx/save.png"));
	saveButton.setToolTipText("salva i dati immessi in un file di testo");
	saveButton.setBackground(new Color (204,204,255));
	buttonPanelSx.add(saveButton);
	saveButton.addActionListener(listener);
	cancNomiButton = new JButton("CANC. NOMI", new ImageIcon("./gfx/delete.png"));
	cancNomiButton.setToolTipText("cancella i nomi di tutti i giocatori");
	cancNomiButton.setBackground(new Color (204,204,255));
	buttonPanelSx.add(cancNomiButton);
	cancNomiButton.addActionListener(listener);
	cancVotiButton = new JButton("CANC. VOTI", new ImageIcon("./gfx/delete.png"));
	cancVotiButton.setToolTipText("cancella i voti di tutti i giocatori");
	cancVotiButton.setBackground(new Color (204,204,255));
	buttonPanelSx.add(cancVotiButton);
	cancVotiButton.addActionListener(listener);
	JPanel buttonPanelDx = new JPanel();			// pannello pulsanti-controllo dx
	buttonPanelDx.setLayout(new GridLayout(3,1));
	buttonPanelDx.setBorder (new EtchedBorder());
	buttonPanelDx.setBackground(new Color (153,153,204));
	aboutButton = new JButton("ABOUT", new ImageIcon("./gfx/!.png"));
	aboutButton.setToolTipText("informazioni generali sul programma");
	aboutButton.setBackground(new Color (204,204,255));
	buttonPanelDx.add(aboutButton);
	aboutButton.addActionListener(listener);
	licenseButton = new JButton("LICENZA", new ImageIcon("./gfx/license.png"));
	licenseButton.setToolTipText("visualizza la licenza del programma");
	licenseButton.setBackground(new Color (204,204,255));
	buttonPanelDx.add(licenseButton);
	licenseButton.addActionListener(listener);
	exitButton = new JButton("ESCI", new ImageIcon("./gfx/stop.png"));
	exitButton.setToolTipText("termina il programma");
	exitButton.setBackground(new Color (204,204,255));
	buttonPanelDx.add(exitButton);
	exitButton.addActionListener(listener);
	JPanel calcolaB = new JPanel();			// pannello per pulsante 'Calcola'
	calcolaB.setLayout(new GridLayout(2,1));
	calcolaB.setBorder (new EtchedBorder());
	calcolaB.setBackground(new Color (153,153,204));
	gazzaButton = new JButton("Apri il file con i voti", new ImageIcon("./gfx/paper.png"));
	gazzaButton.setBackground(Color.pink);
	gazzaButton.setToolTipText("Apre il file contenente i voti dei giocatori");
	gazzaButton.addActionListener(listener);
	calcolaButton = new JButton("Calcola i punti fatti", new ImageIcon("./gfx/gol.gif"));
	calcolaButton.setToolTipText("Calcola i punti fatti e i gol realizzati");
	calcolaButton.addActionListener(listener);
	calcolaB.add(gazzaButton);
	calcolaB.add(calcolaButton);

	JPanel resultsF = new JPanel();			// pannello per campi di testo risultato
	resultsF.setBackground(new Color (153,153,204));
	resultsF.add(resultsField);
	resultsF.add(golLabel); resultsF.add(golField);
	JPanel resultsPanel = new JPanel();			// pannello per risultati
	resultsPanel.setBackground(new Color (153,153,204));
	resultsPanel.add(buttonPanelSx);
	resultsPanel.add(calcolaB);
	resultsPanel.add(resultsF);
	resultsPanel.add(buttonPanelDx);

	JPanel southPanel = new JPanel();			// pannello SOUTH
	southPanel.setBorder (new EtchedBorder());
	southPanel.setBackground(new Color (153,153,204));
	southPanel.add(resultsPanel);

	JPanel nomeSquadraPanel = new JPanel();		// pannello nome squadra
	nomeSquadraPanel.setBackground(new Color (153,153,204));
	nomeSquadraPanel.add(new JLabel("NOME DELLA SQUADRA: "));
	nomeSquadra = new JTextField(20);
	nomeSquadraPanel.add(nomeSquadra);
	JPanel scrittaModuloPanel = new JPanel();		// pannello scritta modulo squadra
	scrittaModuloPanel.setBackground(new Color (153,153,204));
	scrittaModuloField = new JTextField(5);
	scrittaModuloField.setText(""+D+"-"+C+"-"+A);
	scrittaModuloPanel.add(scrittaModuloField);
	JPanel moduloButtonPanel = new JPanel();		// pannello pulsante cambia-modulo
	moduloButton = new JButton("Cambia modulo");
	moduloButton.setToolTipText("Cambia il modulo di gioco della squadra");
	moduloButton.addActionListener(listener);
	moduloButtonPanel.setBackground(new Color (153,153,204));
	moduloButtonPanel.add(moduloButton);

	JPanel northPanel = new JPanel();			// PANNELLO NORTH
	northPanel.setBorder (new EtchedBorder());
	northPanel.setBackground(new Color (153,153,204));
	northPanel.add(nomeSquadraPanel);
	northPanel.add(new JLabel("   MODULO:"));
	northPanel.add(scrittaModuloPanel);
	northPanel.add(moduloButtonPanel);

	Container contentPane = getContentPane();		// DISPOSIZIONE PANNELLI SU FRAME
	contentPane.add(northPanel, "North");
	contentPane.add(centerPanel, "Center");
	contentPane.add(southPanel, "South");
	}

	/** metodo per il salvataggio dei risultati in un file */
	public void saveFile()
	{ int i;
	FileWriter writer = null;
	try
		{ JFileChooser chooser = new JFileChooser();	// mostra la finestra di dialogo
		if (chooser.showSaveDialog(null) == JFileChooser.APPROVE_OPTION)
			{ File selectedFile = chooser.getSelectedFile(); // costruisce file da salvare
			writer = new FileWriter(selectedFile);
			PrintWriter out = new PrintWriter(writer);
			out.println(" --- NOME SQUADRA: " + (nomeSquadra.getText()).toUpperCase() + " ---");
			for(i=1;i<12;i++)
				out.println( (elencoNomi[i].getText()).toUpperCase() + " " + elencoVotiF[i].getText() );
			out.println(" --- Panchina:");
			for(i=12;i<19;i++)
				out.println( (elencoNomi[i].getText()).toUpperCase() + " " + elencoVotiF[i].getText() );
			out.println('\n' + "TOT. PUNTI: "+resultsField.getText()+" => " + "GOL REALIZZATI: "+ golField.getText());
			out.println("_________________________________________"+'\n');
			writer.close();
			}
		}
	catch(IOException e)
		{ JOptionPane.showMessageDialog (null, "Impossibile eseguire il salvataggio." + '\n' +
							"Errore di lettura/scrittura del file: controllare" + '\n' +
							"i permessi di scrittura nella directory corrente.");
		}
	}

	private JButton gazzaButton;				// pulsanti
	private JButton moduloButton;
	private JButton calcolaButton;
	private JButton saveButton;
	private JButton cancNomiButton;
	private JButton cancVotiButton;
	private JButton licenseButton;
	private JButton aboutButton;
	private JButton exitButton;
	private JMenuItem loadMenuItem;			// menu
	private JMenuItem saveMenuItem;
	private JMenuItem statMenuItem;
	private JTextArea avviso;				// campi di testo
	private JTextField nomeSquadra;
	private JTextField scrittaModuloField;
	private JTextField[] elencoNomi;
	private JTextField[] elencoSquadre;
	private JTextField[] elencoVotiP;
	private JTextField[] elencoGolF;
	private JTextField[] elencoGolS;
	private JTextField[] elencoAssist;
	private JTextField[] elencoAmm;
	private JTextField[] elencoEsp;
	private JTextField[] elencoVotiF;
	private JTextField resultsField;
	private JTextField golField;
	private JLabel golLabel;				// etichette
	private JLabel titolariLabel;
	private JLabel panchinaLabel;
	private JLabel tit;
	private JLabel panch;
	private JLabel[] spazio;

	private final String VERSION = "2.6 - 2003.09.21";	// VERSIONE PROGRAMMA

	private class MenuListener implements ActionListener	// intercetta eventi dei menu
	{ public void actionPerformed(ActionEvent mEvent)
		{ Object mSource = mEvent.getSource();		// trova voce del menu scelta
		int i;
		if (mSource == loadMenuItem)			// menu CARICA SQUADRA
			{ try
				{ JFileChooser chooser = new JFileChooser();
				if (chooser.showOpenDialog(null) == JFileChooser.APPROVE_OPTION)
					{File selectedFile = chooser.getSelectedFile();
					BufferedReader formazIn = null;
					formazIn = new BufferedReader(new FileReader(selectedFile));
					String inputFormaz;
					for(i=1;i<19;i++)
						{ inputFormaz = formazIn.readLine();
						if (inputFormaz.endsWith(" ") || inputFormaz.startsWith(" "))
							inputFormaz.trim();
						elencoNomi[i].setText(inputFormaz);
						if (elencoNomi[i].getText().equals(""))
							throw new IllegalArgumentException();
						}
					formazIn.close();
					}
				}
			catch(IOException e)
				{ JOptionPane.showMessageDialog(null, "Errore di apertura del file!");
				}
			catch(IllegalArgumentException e)
				{ JOptionPane.showMessageDialog(null, "Formazione non valida.");
				}
			}
		if (mSource == saveMenuItem)			// menu SALVA SQUADRA
			{ FileWriter formazOut = null;
			try
				{ JFileChooser chooser = new JFileChooser();
				if (chooser.showSaveDialog(null) == JFileChooser.APPROVE_OPTION)
					{ File selectedFile = chooser.getSelectedFile();
					formazOut = new FileWriter(selectedFile);
					PrintWriter fOut = new PrintWriter(formazOut);
					for (i=1;i<19;i++)
						fOut.println(elencoNomi[i].getText().trim());
					formazOut.close();
					}
				}
			catch(IOException e)
				{ JOptionPane.showMessageDialog(null, "Impossibile eseguire il salvataggio." + '\n' +
								"Errore di lettura/scrittura del file: controllare" + '\n' +
								"i permessi di scrittura nella directory corrente.");
				}
			}
		if (mSource == statMenuItem)			// menu DATI SQUADRA
			{ StatFrame statframe = new StatFrame();
			statframe.setTitle("Statistiche dei giocatori");
			Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize(); // posiziona il frame nella pagina
			Dimension StatframeSize = statframe.getSize();
			if (StatframeSize.height > screenSize.height)
				{ StatframeSize.height = screenSize.height;
				}
			if (StatframeSize.width > screenSize.width)
				{ StatframeSize.width = screenSize.width;
				}
			statframe.setLocation((screenSize.width - StatframeSize.width)/2, (screenSize.height - StatframeSize.height)/2);
			statframe.show();
			}
		}
	}
	
	private class ButtonAction implements ActionListener	// intercetta eventi nei pulsanti
	{ public void actionPerformed(ActionEvent event)
		{ Object source = event.getSource();		// trova pulsante premuto
		int i, j;
		String[]input = new String [19];
		double[]newinput = new double [19];

		if (source == moduloButton)			// pulsante Cambia modulo
			{ try
				{ int P = 1;
				int D = Integer.parseInt(scrittaModuloField.getText().substring(0,1));
				int C = Integer.parseInt(scrittaModuloField.getText().substring(2,3));
				int A = Integer.parseInt(scrittaModuloField.getText().substring(4,5));
				if (scrittaModuloField.getText().length()!=5 || D<3 || D>5 || C<3 || C>5 || A<1 || A>3 || (D+C+A)!=10)
					{ scrittaModuloField.setText("");
					throw new IllegalArgumentException();
					}
				elencoVotiF[1].setBackground(new Color(0,0,153));
				for(i=P+1;i<=P+D;i++)
					elencoVotiF[i].setBackground(new Color(0,153,204));
				for(i=P+D+1;i<=P+D+C;i++)
					elencoVotiF[i].setBackground(new Color(0,204,255));
				for(i=P+D+C+1;i<=P+D+C+A;i++)
					elencoVotiF[i].setBackground(new Color(102,255,255));
				}
			catch(IllegalArgumentException e)
				{ JOptionPane.showMessageDialog(null, "MODULO DI GIOCO NON VALIDO!");
				}
			catch(StringIndexOutOfBoundsException e)
				{ JOptionPane.showMessageDialog(null, "MODULO DI GIOCO NON VALIDO!");
				}
			}
		else if (source == gazzaButton)			// pulsante APRI IL FILE DELLA GAZZETTA...
			{ try
				{ for(i=1;i<19;i++)
					if (elencoNomi[i].getText().equals(""))
						throw new NullPointerException();
				JFileChooser chooser = new JFileChooser();
				if (chooser.showOpenDialog(null) == JFileChooser.CANCEL_OPTION)
					{ throw new IOException();
					}
				else { File selectedFile = chooser.getSelectedFile();
					for (i=1;i<19;i++)
						{ elencoVotiP[i].setForeground(Color.black);
						elencoGolF[i].setVisible(true);
						elencoGolS[i].setVisible(true);
						elencoAssist[i].setVisible(true);
						elencoAmm[i].setVisible(true);
						elencoEsp[i].setVisible(true);
						}
					for (i=1;i<19;i++)			// legge e scrive tutti i voti
						{ if(trovaDato.datoFanta(selectedFile, (elencoNomi[i].getText()).trim(), 1).equals(""))
							throw new NullPointerException();
						elencoSquadre[i].setText(trovaDato.datoFanta(selectedFile, (elencoNomi[i].getText()).trim(), 4)); // 4 = squadra giocatore
						elencoVotiP[i].setText(trovaDato.datoFanta(selectedFile, (elencoNomi[i].getText()).trim(), 11)); // 11 = voto partita
						if (elencoVotiP[i].getText().equals("0"))
							{ elencoVotiP[i].setText("s.v.");
							elencoVotiP[i].setForeground(Color.red);
							}
						elencoGolF[i].setText(trovaDato.datoFanta(selectedFile, (elencoNomi[i].getText()).trim(), 12)); // 12 = gol fatti
						if (elencoGolF[i].getText().equals("0"))
							elencoGolF[i].setVisible(false);
						elencoGolS[i].setText(trovaDato.datoFanta(selectedFile, (elencoNomi[i].getText()).trim(), 13)); // 13 = gol subiti
						if (elencoGolS[i].getText().equals("0"))
							elencoGolS[i].setVisible(false);
						elencoAssist[i].setText(trovaDato.datoFanta(selectedFile, (elencoNomi[i].getText()).trim(), 16)); // 16 = assist
						if (elencoAssist[i].getText().equals("0"))
							elencoAssist[i].setVisible(false);
						if ((trovaDato.datoFanta(selectedFile, (elencoNomi[i].getText()).trim(), 17)).equals("1")) // 17 = ammonizioni
							elencoAmm[i].setBackground(Color.yellow);
						   else elencoAmm[i].setVisible(false);
						if ((trovaDato.datoFanta(selectedFile, (elencoNomi[i].getText()).trim(), 18)).equals("1")) // 18 = espulsioni
							elencoEsp[i].setBackground(Color.red);
						   else elencoEsp[i].setVisible(false);
						elencoVotiF[i].setText(trovaDato.datoFanta(selectedFile, (elencoNomi[i].getText()).trim(), 8)); // 8 = voto fantacalcio
						}
					}

				/* algoritmo per la decisione dei cambi */
				int P = 1;
				int D = Integer.parseInt(scrittaModuloField.getText().substring(0,1));
				int C = Integer.parseInt(scrittaModuloField.getText().substring(2,3));
				int A = Integer.parseInt(scrittaModuloField.getText().substring(4,5));
				if (scrittaModuloField.getText().length()!=5 || D<3 || D>5 || C<3 || C>5 || A<1 || A>3 || (D+C+A)!=10)
					{ scrittaModuloField.setText("");
					throw new IllegalArgumentException();
					}
				int p = 0; int d = 0; int c = 0; int a = 0;
				int totcambi = 0;

				// conta quanti cambi dovrebbero essere fatti per ogni ruolo
				if (elencoVotiF[1].getText().equals("0") == true)		// n. sost. portiere
					{ p = 1;
					JOptionPane.showMessageDialog(null, "Portiere da sostituire");
					}
				for (i=(P+1);i<=(P+D);i++)		// n. sost. difensori
					{ if (elencoVotiF[i].getText().equals("0") == true)
					d++;
					}
				JOptionPane.showMessageDialog(null, "Difensori da sostituire: "+d);
				for (i=(P+D+1);i<=(P+D+C);i++)		// n. sost. centrocampisti
					{ if (elencoVotiF[i].getText().equals("0") == true)
					c++;
					}
				JOptionPane.showMessageDialog(null, "Centrocampisti da sostituire: "+c);
				for (i=(P+D+C+1);i<=(P+D+C+A);i++)	// n. sost. attaccanti
					{ if (elencoVotiF[i].getText().equals("0") == true)
					a++;
					}
				JOptionPane.showMessageDialog(null, "Attaccanti da sostituire: "+a);
				int totcambitot = p + d + c + a;
					// sostituzione portiere
				if (p == 0)
					elencoVotiF[12].setText("0");
				if (p == 1 && elencoVotiF[12].getText().equals("0")==true)
					{ JOptionPane.showMessageDialog(null,"Entrambi i portieri non hanno giocato:\nassegnato d'ufficio un voto pari a 3.");
					elencoVotiF[12].setText("3");
					}
				totcambi = p;
					// sostituzioni difensori
				if (d == 0 || (elencoVotiF[13].getText().equals("0")==true && elencoVotiF[14].getText().equals("0")==true) )
					{ d = 0;
					elencoVotiF[13].setText("0");
					elencoVotiF[14].setText("0");
					}
				if (d == 1)
					{ if (elencoVotiF[13].getText().equals("0")==false)
						elencoVotiF[14].setText("0");
					}
				if (d >= 2 && ( (elencoVotiF[13].getText().equals("0")==true && elencoVotiF[14].getText().equals("0")==false) || (elencoVotiF[13].getText().equals("0")==false && elencoVotiF[14].getText().equals("0")==true) ) )
					d = 1;
				totcambi = p + d;
					// sostituzioni centrocampisti
				if (c == 0 || totcambi >= 3 || (elencoVotiF[15].getText().equals("0")==true && elencoVotiF[16].equals("0")==true) )
					{ c = 0;
					elencoVotiF[15].setText("0");
					elencoVotiF[16].setText("0");
					}
				if (c == 1 && totcambi <= 2)
					{ if (elencoVotiF[15].getText().equals("0")==false)
						elencoVotiF[16].setText("0");
					}
				if (c >= 2 && ( (elencoVotiF[15].getText().equals("0")==true && elencoVotiF[16].getText().equals("0")==false) || (elencoVotiF[15].getText().equals("0")==false && elencoVotiF[16].getText().equals("0")==true) ) )
					c  = 1;
				if (c >= 2 && totcambi == 2)
					{ if (elencoVotiF[15].getText().equals("0")==false)
						elencoVotiF[16].setText("0");
					}
				totcambi = p + d + c;
					// sostituzioni attaccanti
				if (a == 0 || totcambi >= 3 || (elencoVotiF[17].getText().equals("0")==true && elencoVotiF[18].equals("0")==true) )
					{ a = 0;
					elencoVotiF[17].setText("0");
					elencoVotiF[18].setText("0");
					}
				if (a == 1 && totcambi <= 2)
					{ if (elencoVotiF[17].getText().equals("0")==false)
						elencoVotiF[18].setText("0");
					}
				if (a >= 2 && totcambi == 2)
					{ if (elencoVotiF[17].getText().equals("0")==false)
						elencoVotiF[18].setText("0");
					}
				if (a >= 2 && totcambi <= 1)
					totcambi = p + d + c + a;
				int ncambifatti = 0;
				for (i=12;i<19;i++)
					if (elencoVotiF[i].getText().equals("0")==false)
						ncambifatti++;
				JOptionPane.showMessageDialog(null, "Cambi effettuati: "+ncambifatti+" su "+totcambitot);
				}
			catch(NullPointerException e)
				{ JOptionPane.showMessageDialog(null, "Formazione non valida o file con i dati errato.");
				}
			catch(StringIndexOutOfBoundsException e)
				{ for (i=1;i<19;i++)
				elencoVotiF[i].setText("");
				JOptionPane.showMessageDialog(null, "MODULO DI GIOCO NON VALIDO!");
				}
			catch(IllegalArgumentException e)
				{ for (i=1;i<19;i++)
				elencoVotiF[i].setText("");
				JOptionPane.showMessageDialog(null, "MODULO DI GIOCO NON VALIDO!");
				}
			catch(IOException e)
				{ JOptionPane.showMessageDialog(null, "Nessun file aperto.");
				}
			}

		else if (source == licenseButton)		// pulsante LICENZA
			{ LFrame lframe = new LFrame();
			lframe.setTitle("GNU GENERAL PUBLIC LICENSE  #  http://www.gnu.org");
			Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize(); // posiziona il frame nella pagina
			Dimension LframeSize = lframe.getSize();
			if (LframeSize.height > screenSize.height)
				{ LframeSize.height = screenSize.height;
				}
			if (LframeSize.width > screenSize.width)
				{ LframeSize.width = screenSize.width;
				}
			lframe.setLocation((screenSize.width - LframeSize.width)/2, (screenSize.height - LframeSize.height)/2);
			lframe.show();
			}
		else if (source == aboutButton)			// pulsante ABOUT
			JOptionPane.showMessageDialog (null, "fantacalcioGUI versione " + VERSION + '\n' +
							     "Autore: Marco Segato <segatom@yahoo.it> aka Mach <tumin17@yahoo.it>" + '\n' + 
							     "Website: http://www.marcosegato.tk"+ '\n' + '\n' +
							     "da un'idea di Nask  AKA  M.in8, assunto come beta-tester ufficiale: GRAZIE!"+ '\n'+ '\n' +
							     "GPL licensed  #  http://www.gnu.org");
		else if (source == cancNomiButton)		// pulsante AZZERA NOMI
			{ for (i=1;i<19;i++)
				{ elencoNomi[i].setText("");
				elencoSquadre[i].setText("");
				}
			}
		else if (source == cancVotiButton)		// pulsante AZZERA VOTI
			{ for(i=1;i<19;i++)
				{ elencoVotiP[i].setText("");
				elencoVotiP[i].setForeground(Color.white);
				elencoGolF[i].setVisible(false);
				elencoGolS[i].setVisible(false);
				elencoAssist[i].setVisible(false);
				elencoAmm[i].setVisible(false);
				elencoEsp[i].setVisible(false);
				}
			for(i=1;i<12;i++)
				elencoVotiF[i].setText("");
			for(i=12;i<19;i++)
				elencoVotiF[i].setText("0");
			resultsField.setText("");
			golField.setText("");
			}
		else if (source == saveButton)			// pulsante SALVA
			saveFile();				
		else if (source == exitButton)			// pulsante ESCI
			System.exit(0);
		else if (source == calcolaButton)		// pulsante x calcolare i punti
			{ for(i=1;i<19;i++)
				input[i]=elencoVotiF[i].getText();
			}
			try
			{ double h = 0;
			int punti = 0;
			for (i=1;i<19;i++)			// converte input (string2double)
				newinput[i] = Double.parseDouble(input[i]);
			for (i=1;i<19;i++)			// calcolo somma
				h = h + newinput[i];
			resultsField.setText("" + h);
			if (h>=66 && h<=71.5) punti = 1;	// calcolo somma punti -> gol fatti
				else if (h>=72 && h<=77.5) punti = 2;
				else if (h>=78 && h<=83.5) punti = 3;
				else if (h>=84 && h<=89.5) punti = 4;
				else if (h>=90 && h<=95.5) punti = 5;
				else if (h>=96 && h<=101.5) punti = 6;
				else if (h>=102 && h<=107.5) punti = 7;
				else if (h>=108 && h<=113.5) punti = 8;
				else if (h>=114 && h<=119.5) punti = 9; // sarebbero quasi 11 pt a giocatore... :))
				else if (h<0 || h>=120) 
					{ JOptionPane.showMessageDialog(null,"Sicuro di aver inserito i voti giusti? ;-)");
					resultsField.setText("");
					}
			golField.setText("" + punti);
			}
			catch(NumberFormatException e)		// eccezione su formato valore del voto
			{ JOptionPane.showMessageDialog (null, "Errore nel calcolo: devi inserire i voti di TUTTI i calciatori!" + '\n' +
								"NB: i voti con la virgola devono essere scritti nel formato '6.5' .");
			resultsField.setText("");
			golField.setText("");
			}
			catch(NullPointerException e)		// eccezione NullPointer controllata, ma da dove arriva? :))
			{ aboutButton.setSelected(true);
			}
		}
	}

	private class WindowCloser extends WindowAdapter	// chiude finestra
	{ public void windowClosing(WindowEvent event)
		{ System.exit(0);
		}
	}
}
